unit UShellExecuteEx;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses ShellAPI;
var SInfo: TShellExecuteInfo;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if OpenDialog1.Execute
  then begin
   SInfo.Wnd := Handle;
   SInfo.nShow := 0;
   if Sender = Button1
    then SInfo.lpVerb := 'open'
    else SInfo.lpVerb := 'edit';
   SInfo.lpFile := PChar(OpenDialog1.FileName);
   SInfo.cbSize := sizeof(SInfo);
   if not ShellExecuteEx(@SInfo)
   then case SInfo.hInstApp of
    SE_ERR_FNF: ShowMessage('Файл не найден');
    SE_ERR_PNF:	ShowMessage('Путь не найден');
    SE_ERR_ACCESSDENIED: ShowMessage('Доступ к файлу запрещен');
    SE_ERR_OOM: ShowMessage('Не хватает памяти');
    SE_ERR_DLLNOTFOUND: ShowMessage('Не найдена необходимая DLL');
    SE_ERR_SHARE: ShowMessage('Файл захвачен другим пользователем');
    SE_ERR_ASSOCINCOMPLETE: ShowMessage('Не полная информация о связанном с файлом приложении');
    SE_ERR_DDETIMEOUT: ShowMessage('Истекло время на выполнение операции DDE');
    SE_ERR_DDEFAIL: ShowMessage('Ошибочная операция DDE');
    SE_ERR_DDEBUSY: ShowMessage('Операция DDE занята');
    SE_ERR_NOASSOC: ShowMessage('Нет приложения, связанного с файлом');
   end
   else Button3.Enabled := true;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 SInfo.lpVerb := 'print';
 ShellExecuteEx(@SInfo);
end;

end.
